#
# Terran Land-Based Cruise Missile
#
---local UEOW_0301_ASC_Missile = import('/lua/terranprojectiles.lua').UEOW_0301_ASC_Missile

local UEOW_0301_ASC_Missile = import('/mods/OrbitalWarsRebornUEFAlpha/hook/lua/UEOW0301/UEOW0301projectiles.lua').UEOW_0301_ASC_Missile
local EffectTemplate = import('/lua/EffectTemplates.lua')



UEOW0301_ASC_Missile = Class(UEOW_0301_ASC_Missile) {


	InitialEffects = {'/effects/emitters/nuke_munition_launch_trail_02_emit.bp',},
    ThrustEffects = {'/effects/emitters/nuke_munition_launch_trail_04_emit.bp',
                     '/effects/emitters/nuke_munition_launch_trail_06_emit.bp',
    },
	

    FxTrails = EffectTemplate.TMissileExhaust01,
    FxTrailOffset = -1.85,
    
    FxAirUnitHitScale = 1.65,
    FxLandHitScale = 1.65,
    FxNoneHitScale = 1.65,
    FxPropHitScale = 1.65,
    FxProjectileHitScale = 1.65,
    FxProjectileUnderWaterHitScale = 1.65,
    FxShieldHitScale = 1.65,
    FxUnderWaterHitScale = 1.65,
    FxUnitHitScale = 1.65,
    FxWaterHitScale = 1.65,
    FxOnKilledScale = 1.65,

	CreateEffects = function( self, EffectTable, army, scale)
        for k, v in EffectTable do
            self.Trash:Add(CreateAttachedEmitter(self, -1, army, v):ScaleEmitter(scale))
        end
    end,
	
	OnCreate = function(self)
        UEOW_0301_ASC_Missile.OnCreate(self)
        self:ForkThread( self.MovementThread )
    end,
	
	MovementThread = function(self)
        local army = self:GetArmy()
		self.CreateEffects( self, self.InitialEffects, army, 1 )
        WaitSeconds(2)
        self:SetAcceleration(100)
		self.CreateEffects( self, self.ThrustEffects, army, -3 )
    end,

}
TypeClass = UEOW0301_ASC_Missile

