#****************************************************************************
#**
#**  File     :  /cdimage/units/UEA0103/UEA0103_script.lua
#**  Author(s):  John Comes, David Tomandl, Gordon Duclos
#**
#**  Summary  :  Terran Orbital Fighter T1 Unit Script
#**
#**  Copyright  2005 Gas Powered Games, Inc.  All rights reserved.
#****************************************************************************

local TAirUnit = import('/lua/terranunits.lua').TAirUnit
--Test Gatling
local TAMPhalanxWeapon = import('/lua/terranweapons.lua').TAirToAirLinkedRailgun

local Entity = import('/lua/sim/Entity.lua').Entity
local explosion = import('/lua/defaultexplosions.lua')
local CreateDeathExplosion = explosion.CreateDefaultHitExplosionAtBone
local EffectTemplate = import('/lua/EffectTemplates.lua')
local utilities = import('/lua/Utilities.lua')
local EffectUtil = import('/lua/EffectUtilities.lua')

UEOW0101 = Class(TAirUnit) {
    Weapons = {
		Gatling01 = Class(TAMPhalanxWeapon) {            
        },
    },
	
	OnStopBeingBuilt = function(self)
		self.AT1 = self:ForkThread(self.ArrivalThread, true)
        TAirUnit.OnStopBeingBuilt(self)
    end,
	
	CreateDeathExplosionDustRing = function( self )
        local blanketSides = 18
        local blanketAngle = (2*math.pi) / blanketSides
        local blanketStrength = 1
        local blanketVelocity = 2.8

        for i = 0, (blanketSides-1) do
            local blanketX = math.sin(i*blanketAngle)
            local blanketZ = math.cos(i*blanketAngle)

            local Blanketparts = self:CreateProjectile('/effects/entities/DestructionDust01/DestructionDust01_proj.bp', blanketX, 1.5, blanketZ + 4, blanketX, 0, blanketZ)
                :SetVelocity(blanketVelocity):SetAcceleration(-0.3)
        end        
    end,
	
	ArrivalThread = function(self)
		WaitSeconds(0.5)
        self:PlayUnitSound('Destroyed')
        local army = self:GetArmy()
		WaitSeconds(1)
		local totalBones = self:GetBoneCount() - 1
        local army = self:GetArmy()
		for k, v in EffectTemplate.SmokeSml01 do
            for bone = 1, totalBones do
                CreateAttachedEmitter(self,bone,army, v)
            end
        end
        WaitSeconds(0.5)
        for k, v in EffectTemplate.SmokeSml01 do
            for bone = 1, totalBones do
                CreateAttachedEmitter(self,bone,army, v)
            end
        end
		WaitSeconds(0.6)
		explosion.CreateFlash( self, 'UEOW0101', 1.0, army )
        CreateDeathExplosion( self, 'UEOW0101', 1.0)
		self:PlayUnitSound('Destroyed')
		for k, v in EffectTemplate.SmokeSml01 do
            for bone = 1, totalBones do
                CreateAttachedEmitter(self,bone,army, v)
            end
        end
		WaitSeconds(0.5)
		for k, v in EffectTemplate.SmokeSml01 do
            for bone = 1, totalBones do
                CreateAttachedEmitter(self,bone,army, v)
            end
        end
    end,
	
}

TypeClass = UEOW0101

