--[[#######################################################################
#  File     :  /units/UEA0306/UEA0306_script.lua
#  Author(s):  John Comes, David Tomandl
#  Summary  :  UEF Tech 3  Orbital fighter 
#  -----------------------------
#  Modif.by :  AsdrubaelVect
#  Rev.Date :  5 septembre 2009
#  -----------------------------
#  Revis.by :  Manimal
#  Rev.Date :  20 novembre 2009
#  -----------------------------
#  Copyright  2005 Gas Powered Games, Inc.  All rights reserved.
#######################################################################]]--


local TAirUnit = import('/lua/terranunits.lua').TAirUnit

local TAAGinsuRapidPulseWeapon = import('/lua/terranweapons.lua').TAAGinsuRapidPulseWeapon
local TIFCruiseMissileUnpackingLauncher = import('/lua/terranweapons.lua').TIFCruiseMissileUnpackingLauncher
local TAAGinsuRapidPulseWeapon = import('/lua/terranweapons.lua').TAAGinsuRapidPulseWeapon

local UEOW_0301_ASC_Missile = import('/mods/OrbitalWarsRebornUEFAlpha/hook/lua/UEOW0301/UEOW0301weapons.lua').UEOW_0301_ASC_Missile

UEA0306 = Class(TAirUnit) {
	
	Weapons = {
        MissileWeapon = Class(UEOW_0301_ASC_Missile) {
            FxMuzzleFlash = {'/effects/emitters/terran_mobile_missile_launch_01_emit.bp'},
		IdleState = State (UEOW_0301_ASC_Missile.IdleState) {
                Main = function(self)
                    UEOW_0301_ASC_Missile.IdleState.Main(self)
                end,
                
                OnGotTarget = function(self)
                    self.unit:SetBreakOffTriggerMult(2.0)
                    self.unit:SetBreakOffDistanceMult(8.0)
                    self.unit:SetSpeedMult(1)
                    UEOW_0301_ASC_Missile.IdleState.OnGotTarget(self)
                end,            
            },
        
            OnGotTarget = function(self)
                self.unit:SetBreakOffTriggerMult(2.0)
                self.unit:SetBreakOffDistanceMult(8.0)
                self.unit:SetSpeedMult(1)
                UEOW_0301_ASC_Missile.OnGotTarget(self)
            end,
        
            OnLostTarget = function(self)
                self.unit:SetBreakOffTriggerMult(1.0)
                self.unit:SetBreakOffDistanceMult(1.0)
                self.unit:SetSpeedMult(1.0)
                UEOW_0301_ASC_Missile.OnLostTarget(self)
            end,
        },
		AABeam = Class(TAAGinsuRapidPulseWeapon) {},
		AABeam2 = Class(TAAGinsuRapidPulseWeapon) {},
    },
	
}

TypeClass = UEA0306
