#****************************************************************************
#**
#**  File     :  /units/UEOW1102/UEOW1102_script.lua
#**  Author(s):  Drew Staltman, Gordon Duclos, Greg Kohne
#**					Modified By Asdrubaelvect
#**  Summary  :  UEF Spaceships t2 Script
#**
#**  Copyright  2007 Gas Powered Games, Inc.  All rights reserved.
#****************************************************************************

local TSeaUnit = import('/lua/terranunits.lua').TSeaUnit
local TAirUnit = import('/lua/terranunits.lua').TAirUnit
local TSAMLauncher = import('/lua/terranweapons.lua').TSAMLauncher
local TDFHiroPlasmaCannon = import('/lua/terranweapons.lua').TDFHiroPlasmaCannon
local TOrbitalDeathLaserBeamWeapon = import('/lua/terranweapons.lua').TOrbitalDeathLaserBeamWeapon
local util = import('/lua/utilities.lua')
local fxutil = import('/lua/effectutilities.lua')


local Entity = import('/lua/sim/Entity.lua').Entity
local explosion = import('/lua/defaultexplosions.lua')
local CreateDeathExplosion = explosion.CreateDefaultHitExplosionAtBone
local EffectTemplate = import('/lua/EffectTemplates.lua')
local utilities = import('/lua/Utilities.lua')
local EffectUtil = import('/lua/EffectUtilities.lua')

--AA
local Efof_1102_AA_Cannon = import('/mods/OrbitalWarsRebornUEFAlpha/hook/lua/EFOF1102/efof1102weapons.lua').Efof_1102_AA_Cannon

--Test Gatling
local TAMPhalanxWeapon = import('/lua/terranweapons.lua').TAMPhalanxWeapon

--Arme Anti Spaceships
local efof_1102_AntiSpaceships_Projectile = import('/mods/OrbitalWarsRebornUEFAlpha/hook/lua/EFOF1102/efof1102weapons.lua').efof_1102_AntiSpaceships_Projectile


UEOW1102 = Class(TAirUnit) {
	DestroyNoFallRandomChance = 1.1,
    Weapons = {
		--HiroCannonFront = Class(TDFHiroPlasmaCannon) {},
		--HiroCannonBack = Class(TDFHiroPlasmaCannon) {},
		OrbitalDeathLaserWeapon = Class(TOrbitalDeathLaserBeamWeapon){},
		AntiSpaceships01 = Class(efof_1102_AntiSpaceships_Projectile) {},
		AntiSpaceships02 = Class(efof_1102_AntiSpaceships_Projectile) {},
		AntiSpaceships03 = Class(efof_1102_AntiSpaceships_Projectile) {},
		AntiSpaceships04 = Class(efof_1102_AntiSpaceships_Projectile) {},
		AAGun01 = Class(Efof_1102_AA_Cannon) {},
		AAGun02 = Class(Efof_1102_AA_Cannon) {},
		AAGun03 = Class(Efof_1102_AA_Cannon) {},
		AAGun04 = Class(Efof_1102_AA_Cannon) {},
		Gatling01 = Class(TAMPhalanxWeapon) {
                PlayFxWeaponUnpackSequence = function(self)
                    if not self.SpinManip then 
                        self.SpinManip = CreateRotator(self.unit, 'Gatling_Canon01', 'z', nil, 270, 180, 60)
                        self.unit.Trash:Add(self.SpinManip)
                    end
                    if self.SpinManip then
                        self.SpinManip:SetTargetSpeed(270)
                    end
                    TAMPhalanxWeapon.PlayFxWeaponUnpackSequence(self)
                end,

                PlayFxWeaponPackSequence = function(self)
                    if self.SpinManip then
                        self.SpinManip:SetTargetSpeed(0)
                    end
                    TAMPhalanxWeapon.PlayFxWeaponPackSequence(self)
                end,
            
        },
		Gatling02 = Class(TAMPhalanxWeapon) {
                PlayFxWeaponUnpackSequence = function(self)
                    if not self.SpinManip then 
                        self.SpinManip = CreateRotator(self.unit, 'Gatling_Canon02', 'z', nil, 270, 180, 60)
                        self.unit.Trash:Add(self.SpinManip)
                    end
                    if self.SpinManip then
                        self.SpinManip:SetTargetSpeed(270)
                    end
                    TAMPhalanxWeapon.PlayFxWeaponUnpackSequence(self)
                end,

                PlayFxWeaponPackSequence = function(self)
                    if self.SpinManip then
                        self.SpinManip:SetTargetSpeed(0)
                    end
                    TAMPhalanxWeapon.PlayFxWeaponPackSequence(self)
                end,
            
        },
		Gatling03 = Class(TAMPhalanxWeapon) {
                PlayFxWeaponUnpackSequence = function(self)
                    if not self.SpinManip then 
                        self.SpinManip = CreateRotator(self.unit, 'Gatling_Canon03', 'z', nil, 270, 180, 60)
                        self.unit.Trash:Add(self.SpinManip)
                    end
                    if self.SpinManip then
                        self.SpinManip:SetTargetSpeed(270)
                    end
                    TAMPhalanxWeapon.PlayFxWeaponUnpackSequence(self)
                end,

                PlayFxWeaponPackSequence = function(self)
                    if self.SpinManip then
                        self.SpinManip:SetTargetSpeed(0)
                    end
                    TAMPhalanxWeapon.PlayFxWeaponPackSequence(self)
                end,
            
        },
		Gatling04 = Class(TAMPhalanxWeapon) {
                PlayFxWeaponUnpackSequence = function(self)
                    if not self.SpinManip then 
                        self.SpinManip = CreateRotator(self.unit, 'Gatling_Canon04', 'z', nil, 270, 180, 60)
                        self.unit.Trash:Add(self.SpinManip)
                    end
                    if self.SpinManip then
                        self.SpinManip:SetTargetSpeed(270)
                    end
                    TAMPhalanxWeapon.PlayFxWeaponUnpackSequence(self)
                end,

                PlayFxWeaponPackSequence = function(self)
                    if self.SpinManip then
                        self.SpinManip:SetTargetSpeed(0)
                    end
                    TAMPhalanxWeapon.PlayFxWeaponPackSequence(self)
                end,
            
        },
		Gatling05 = Class(TAMPhalanxWeapon) {
                PlayFxWeaponUnpackSequence = function(self)
                    if not self.SpinManip then 
                        self.SpinManip = CreateRotator(self.unit, 'Gatling_Canon05', 'z', nil, 270, 180, 60)
                        self.unit.Trash:Add(self.SpinManip)
                    end
                    if self.SpinManip then
                        self.SpinManip:SetTargetSpeed(270)
                    end
                    TAMPhalanxWeapon.PlayFxWeaponUnpackSequence(self)
                end,

                PlayFxWeaponPackSequence = function(self)
                    if self.SpinManip then
                        self.SpinManip:SetTargetSpeed(0)
                    end
                    TAMPhalanxWeapon.PlayFxWeaponPackSequence(self)
                end,
            
        },
		Gatling06 = Class(TAMPhalanxWeapon) {
                PlayFxWeaponUnpackSequence = function(self)
                    if not self.SpinManip then 
                        self.SpinManip = CreateRotator(self.unit, 'Gatling_Canon06', 'z', nil, 270, 180, 60)
                        self.unit.Trash:Add(self.SpinManip)
                    end
                    if self.SpinManip then
                        self.SpinManip:SetTargetSpeed(270)
                    end
                    TAMPhalanxWeapon.PlayFxWeaponUnpackSequence(self)
                end,

                PlayFxWeaponPackSequence = function(self)
                    if self.SpinManip then
                        self.SpinManip:SetTargetSpeed(0)
                    end
                    TAMPhalanxWeapon.PlayFxWeaponPackSequence(self)
                end,
            
        },
		Gatling07 = Class(TAMPhalanxWeapon) {
                PlayFxWeaponUnpackSequence = function(self)
                    if not self.SpinManip then 
                        self.SpinManip = CreateRotator(self.unit, 'Gatling_Canon07', 'z', nil, 270, 180, 60)
                        self.unit.Trash:Add(self.SpinManip)
                    end
                    if self.SpinManip then
                        self.SpinManip:SetTargetSpeed(270)
                    end
                    TAMPhalanxWeapon.PlayFxWeaponUnpackSequence(self)
                end,

                PlayFxWeaponPackSequence = function(self)
                    if self.SpinManip then
                        self.SpinManip:SetTargetSpeed(0)
                    end
                    TAMPhalanxWeapon.PlayFxWeaponPackSequence(self)
                end,
            
        },
		Gatling08 = Class(TAMPhalanxWeapon) {
                PlayFxWeaponUnpackSequence = function(self)
                    if not self.SpinManip then 
                        self.SpinManip = CreateRotator(self.unit, 'Gatling_Canon08', 'z', nil, 270, 180, 60)
                        self.unit.Trash:Add(self.SpinManip)
                    end
                    if self.SpinManip then
                        self.SpinManip:SetTargetSpeed(270)
                    end
                    TAMPhalanxWeapon.PlayFxWeaponUnpackSequence(self)
                end,

                PlayFxWeaponPackSequence = function(self)
                    if self.SpinManip then
                        self.SpinManip:SetTargetSpeed(0)
                    end
                    TAMPhalanxWeapon.PlayFxWeaponPackSequence(self)
                end,
            
        },
	},


	OnKilled = function(self, instigator, type, overkillRatio)
        local wep = self:GetWeaponByLabel('OrbitalDeathLaserWeapon')
        for k, v in wep.Beams do
            v.Beam:Disable()
        end

        self.detector = CreateCollisionDetector(self)
        self.Trash:Add(self.detector)
        self.detector:WatchBone('UEOW1102')
        self.detector:WatchBone('TourelleGrosCanon01')
        self.detector:WatchBone('TourelleGrosCanon02')
        self.detector:WatchBone('Reacteur01')
        self.detector:WatchBone('Reacteur02')
        self.detector:WatchBone('Reacteur05')
        self.detector:WatchBone('Reacteur06')
        --self.detector:WatchBone('Attachpoint02')
        self.detector:EnableTerrainCheck(true)
        self.detector:Enable()


        TAirUnit.OnKilled(self, instigator, type, overkillRatio)
    end,

    OnAnimTerrainCollision = function(self, bone,x,y,z)
        DamageArea(self, {x,y,z}, 5, 100, 'Default', true, false)
        explosion.CreateDefaultHitExplosionAtBone( self, bone, 5.0 )
        explosion.CreateDebrisProjectiles(self, explosion.GetAverageBoundingXYZRadius(self), {self:GetUnitSizes()})
    end,
	
	
	
	DeathThread = function(self)
        self:PlayUnitSound('Destroyed')
        local army = self:GetArmy()

        explosion.CreateFlash( self, 'TourelleGrosCanon01', 6.5, army )
        CreateAttachedEmitter(self, 'UEOW1102', army, '/effects/emitters/destruction_explosion_concussion_ring_03_emit.bp')
        CreateAttachedEmitter(self,'TourelleGrosCanon01', army, '/effects/emitters/explosion_fire_sparks_02_emit.bp')
        self:CreateFirePlumes( army, {'TourelleGrosCanon01'}, 2 )
		self:CreateFirePlumes( army, {'TourelleGrosCanon02'}, 10 )
		self:CreateFirePlumes( army, {'TourelleGrosCanon03'}, 10 )
		self:CreateFirePlumes( army, {'TourelleGrosCanon04'}, 0 )
		self:CreateFirePlumes( army, {'AA_Droite_01_Part01'}, 0 )
		self:CreateFirePlumes( army, {'AA_Droite_02_Part01'}, 0 )
		self:CreateFirePlumes( army, {'AA_Droite_03_Part01'}, 0 )
		self:CreateFirePlumes( army, {'AA_Droite_04_Part01'}, 0 )

        self:CreateFirePlumes( army, {'TourelleGrosCanon01','TourelleGrosCanon02','TourelleGrosCanon03',}, 22.5 )

        self:CreateExplosionDebris( army )
        self:CreateExplosionDebris( army )
        self:CreateExplosionDebris( army )

        WaitSeconds(0.1)
        

        CreateDeathExplosion( self, 'UEOW1102', 1.5)
        self:CreateDamageEffects( 'TourelleGrosCanon01', army )
        self:CreateDamageEffects( 'TourelleGrosCanon02', army )
        self:CreateFirePlumes( army, {'TourelleGrosCanon01','TourelleGrosCanon02','TourelleGrosCanon03',}, 2.5 )
        WaitSeconds(0.2)
        self:CreateDeathExplosionDustRing()
        WaitSeconds(0.1)

        self:ShakeCamera(50, 5, 0, 1)
        CreateDeathExplosion( self, 'UEOW1102', 1)
        for k, v in EffectTemplate.FootFall01 do
            CreateAttachedEmitter(self,'UEOW1102',army, v):ScaleEmitter(5)          
            CreateAttachedEmitter(self,'UEOW1102',army, v):ScaleEmitter(5) 
        end

        self:CreateExplosionDebris( army )
        self:CreateExplosionDebris( army )

        local x, y, z = unpack(self:GetPosition())
        z = z + 3
        DamageRing(self, {x,y,z}, 0.1, 3, 1, 'Force', true)
        WaitSeconds(0.1)
        CreateDeathExplosion( self, 'UEOW1102', 2)

        DamageRing(self, {x,y,z}, 0.1, 3, 1, 'Force', true)


        CreateDeathExplosion( self, 'TourelleGrosCanon01', 2)
        self:CreateFirePlumes( army, {'TourelleGrosCanon02'}, 15 )
        self:CreateDamageEffects( 'TourelleGrosCanon02', army )
        self:CreateDamageEffects( 'TourelleGrosCanon01', army )
        CreateDeathExplosion( self, 'TourelleGrosCanon01', 1)
        self:CreateExplosionDebris( army )
        CreateDeathExplosion( self, 'TourelleGrosCanon01', 2 )
        self:CreateDamageEffects( 'TourelleGrosCanon02', army )
        self:CreateWreckage(0.1)
        self:Destroy()
    end,
	
	
	
	OnStopBeingBuilt = function(self)
		self.AT1 = self:ForkThread(self.ArrivalThread, true)
        TAirUnit.OnStopBeingBuilt(self)
    end,
	
	CreateDamageEffects = function(self, bone, army )
        for k, v in EffectTemplate.DamageFireSmoke01 do
            CreateAttachedEmitter( self, bone, army, v ):ScaleEmitter(1.5)
        end
    end,

    CreateDeathExplosionDustRing = function( self )
        local blanketSides = 18
        local blanketAngle = (2*math.pi) / blanketSides
        local blanketStrength = 1
        local blanketVelocity = 2.8

        for i = 0, (blanketSides-1) do
            local blanketX = math.sin(i*blanketAngle)
            local blanketZ = math.cos(i*blanketAngle)

            local Blanketparts = self:CreateProjectile('/effects/entities/DestructionDust01/DestructionDust01_proj.bp', blanketX, 1.5, blanketZ + 4, blanketX, 0, blanketZ)
                :SetVelocity(blanketVelocity):SetAcceleration(-0.3)
        end        
    end,

	CreateFirePlumes = function( self, army, bones, yBoneOffset )
        local proj, position, offset, velocity
        local basePosition = self:GetPosition()
        for k, vBone in bones do
            position = self:GetPosition(vBone)
            offset = utilities.GetDifferenceVector( position, basePosition )
            velocity = utilities.GetDirectionVector( position, basePosition ) # 
            velocity.x = velocity.x + utilities.GetRandomFloat(-0.3, 0.3)
            velocity.z = velocity.z + utilities.GetRandomFloat(-0.3, 0.3)
            velocity.y = velocity.y + utilities.GetRandomFloat( 0.0, 0.3)
            proj = self:CreateProjectile('/effects/entities/DestructionFirePlume01/DestructionFirePlume01_proj.bp', offset.x, offset.y + yBoneOffset, offset.z, velocity.x, velocity.y, velocity.z)
            proj:SetBallisticAcceleration(utilities.GetRandomFloat(-1, -2)):SetVelocity(utilities.GetRandomFloat(3, 4)):SetCollision(false)
            
            local emitter = CreateEmitterOnEntity(proj, army, '/effects/emitters/destruction_explosion_fire_plume_02_emit.bp')

            local lifetime = utilities.GetRandomFloat( 12, 22 )
        end
    end,
	
	CreateExplosionDebris = function( self, army )
        for k, v in EffectTemplate.ExplosionDebrisLrg01 do
            CreateAttachedEmitter( self, 'UEOW1102', army, v )
        end
    end,
	
	ArrivalThread = function(self)
		WaitSeconds(1.5)
        self:PlayUnitSound('Destroyed')
		WaitSeconds(2.0)
        self:PlayUnitSound('Destroyed')
        local army = self:GetArmy()
		WaitSeconds(7.5)
        # Create Initial explosion effects
        explosion.CreateFlash( self, 'UEOW1102', 4.5, army )
		explosion.CreateFlash( self, 'Reacteur01', 2.5, army )
		explosion.CreateFlash( self, 'Reacteur02', 2.5, army )
		explosion.CreateFlash( self, 'Reacteur03', 2.5, army )
		explosion.CreateFlash( self, 'Reacteur04', 2.5, army )
		explosion.CreateFlash( self, 'Reacteur05', 2.5, army )
		explosion.CreateFlash( self, 'Reacteur06', 2.5, army )
		WaitSeconds(2.5)
		self:PlayUnitSound('Destroyed')

        WaitSeconds(1)
        
        CreateDeathExplosion( self, 'UEOW1102', 1.5)

        WaitSeconds( 1 )
        self:CreateDeathExplosionDustRing()
		self:PlayUnitSound('Destroyed')
        WaitSeconds(0.4)
		
	#############COMMANDER	
		local totalBones = self:GetBoneCount() - 1
        local army = self:GetArmy()
        for k, v in EffectTemplate.SmokeLrg01 do
            for bone = 1, totalBones do
                CreateAttachedEmitter(self,bone,army, v)
            end
        end
		WaitSeconds(1)
		explosion.CreateFlash( self, 'UEOW1102', 4.5, army )
		explosion.CreateFlash( self, 'Reacteur01', 2.5, army )
		explosion.CreateFlash( self, 'Reacteur02', 2.5, army )
		explosion.CreateFlash( self, 'Reacteur03', 2.5, army )
		explosion.CreateFlash( self, 'Reacteur04', 2.5, army )
		explosion.CreateFlash( self, 'Reacteur05', 2.5, army )
		explosion.CreateFlash( self, 'Reacteur06', 2.5, army )
		WaitSeconds(1)
		for k, v in EffectTemplate.SmokeLrg01 do
            for bone = 1, totalBones do
                CreateAttachedEmitter(self,bone,army, v)
            end
        end
		WaitSeconds(1.8)
		for k, v in EffectTemplate.SmokeLrg01 do
            for bone = 1, totalBones do
                CreateAttachedEmitter(self,bone,army, v)
            end
        end
		WaitSeconds(1.8)
		for k, v in EffectTemplate.SmokeLrg01 do
            for bone = 1, totalBones do
                CreateAttachedEmitter(self,bone,army, v)
            end
        end
	#############COMMANDER
        WaitSeconds(0.5)
        CreateDeathExplosion( self, 'UEOW1102', 2)
    end,

}

TypeClass = UEOW1102